/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "item.h"
#include "misc.h"



Item::Item()
{
	Clear();
}


void Item::SetDateToNow()
{
	date_creation     = Time(std::time(0));
	date_modification = date_creation;
}


void Item::SetDateModifyToNow()
{
	date_modification = Time(std::time(0));
}


void Item::Clear()
{
	id = -1;
	
	user_id = -1;
	group_id = -1;
	privileges = 0;
	modification_user_id = -1;

	guest_name.clear();
	
	subject.clear();
	content.clear();
	modify_index = 0;
	url.clear();	
	
	content_type = ct_formatted_text;
	
	type = none;
	parent_id = -1;

	link_to.clear();
	link_redirect = false;

	content_id = -1;
	ref = 1;

	file_path.clear();
	file_fs   = -1;
	file_type = WINIX_ITEM_FILETYPE_NONE;

	has_thumb = false;

	html_template.clear();

	SetDateToNow();
}


