/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfilecmslucoreusers
#define headerfilecmslucoreusers

#include <map>
#include "user.h"
#include "ugcontainer.h"
#include "lastcontainer.h"
#include "request.h"
#include "db/db.h"


class Users
{
typedef UGContainer<User> Table;
Table table;

	Request * request;
	long how_many_logged;

public:

	typedef Table::Iterator Iterator;
	typedef Table::SizeType SizeType;

	LastContainer last;

	Users();

	void SetRequest(Request * request);

	void Clear();
	void ReadUsers(Db * db);
	void SetTimeZoneOffset(int offset); // !! temporarily one time_zone for all users
	bool AddUser(const User & user);
	bool IsUser(const std::wstring & name);
	User * GetUser(long user_id);
	User * GetUser(const std::wstring & name);
	long GetUserId(const std::wstring & name);
	Iterator Begin();
	Iterator End();
	SizeType Size();
	User & operator[](SizeType pos);

	void LoginUser(long user_id, bool remember_me);
	void LogoutCurrentUser();

	void IncrementLoggedUsers();
	long HowManyLogged();
};








#endif
