/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfilecmslucorefunctionparser
#define headerfilecmslucorefunctionparser

#include "core/request.h"
#include "db/db.h"
#include "core/system.h"


class Functions;



class FunctionParser
{
	Request   * request;
	Db        * db;
	Functions * functions;
	System    * system;

	GetTab::size_type get_index;
	GetTab::size_type get_tab_len;
	
	void SkipEmptyString(const char * msg);
	
	void ParseDirectories();
	void ParseItem();
	bool IsAppFunction();
	void ParseFunction();
	void ParseParams(const std::wstring & par);
	void ParseParams();

public:

	void Parse(Request * prequest, Db * pdb, Functions * pfunctions, System * psystem);

};


#endif
