/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_plugins_thread_tdb
#define headerfile_winix_plugins_thread_tdb


#include <vector>
#include "ticket.h"
#include "db/dbbase.h"
#include "core/error.h"


namespace Thread
{


class TDb : public DbBase
{
public:

	Error AddThread(Thread & thread);
	Error GetThreadByDirId(long dir_id, Thread & thread);
	Error GetThreads(long parent_id, std::vector<Thread> & thread_tab);
	Error EditThreadAddItem(long dir_id, long item_id);
	Error EditThreadRemoveItem(long dir_id);
	Error RemoveThread(long dir_id);


private:

	DbTextStream query;

};


} // namespace


#endif

