/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_plugins_ticket_editticket
#define headerfile_winix_plugins_ticket_editticket

#include "tdb.h"
#include "ticket.h"
#include "ticketinfo.h"
#include "functions/functionbase.h"


namespace Ticket
{


class EditTicket : public FunctionBase
{
public:

	EditTicket();
	void SetTDb(TDb * ptdb);
	void SetTicketInfo(TicketInfo * pinfo);

	bool HasAccess();
	void MakePost();
	void MakeGet();

private:

	void RemoveTicket();
	Ticket & PrepareTicket();
	std::vector<long> & PrepareFileMap();
	std::wstring old_url;

	void ChangeTicket(Ticket & ticket, Item & item);
	void Submit(Ticket & ticket, Item & item);

	TDb * tdb;
	TicketInfo * ticket_info;
};


} // namespace

#endif
