/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_plugins_ticket_sessiondata
#define headerfile_winix_plugins_ticket_sessiondata

#include <vector>
#include <string>
#include <map>
#include "core/plugindata.h"
#include "ticket.h"


namespace Ticket
{


struct SessionData : public PluginDataBase
{
	typedef std::map<long, Ticket>              TicketMap;
	typedef std::map<long, std::vector<long> >  FileMap;

	// temporary tickets for 'createticket' function
	// <parent_dir_id, Ticket>
	TicketMap create_ticket_map;

	// temporary tickets for 'editticket' function
	// <file_id, Ticket>
	TicketMap edit_ticket_map;

	// temporary files for 'editticket' function
	// these files should be deleted if a user will not click on the submit button
	FileMap new_file_map;


	// inserting and returning a new ticket or just returning the ticket if it exists
	Ticket & GetTicket(long id, TicketMap & ticket_map, bool * is_new = 0);

	std::vector<long> & GetFileTab(long id, FileMap & file_map);

};


} // namespace


#endif
