/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_plugins_ticket_showtickets
#define headerfile_winix_plugins_ticket_showtickets

#include "tdb.h"
#include "ticketinfo.h"
#include "core/item.h"
#include "functions/functionbase.h"


namespace Ticket
{


class ShowTickets : public FunctionBase
{
public:

	ShowTickets();
	void SetTDb(TDb * ptdb);
	void SetTicketInfo(TicketInfo * pinfo);

	bool HasAccess();
	void MakeGet();

private:

	TDb * tdb;
	TicketInfo * ticket_info;
	std::vector<long> file_id_tab;

	void ReadFiles();
	void ReadTickets();
	void CreatePointers();
	void SortPointers();
	
	struct Sort
	{
		ShowTickets * show_tickets;
		int sort_type;
		Sort(ShowTickets * show, int type) : show_tickets(show), sort_type(type) {}
		bool operator()(const Item * item1, const Item * item2);
	};

};


} // namespace

#endif
