#ifndef headerfile_winix_plugins_ticket_ticketconf
#define headerfile_winix_plugins_ticket_ticketconf

#include <vector>
#include <string>




struct TicketConf
{
	struct TicketItem
	{
		struct Select
		{
			std::wstring name;
			int id;
		};

		TicketItem();
		void Clear();

		enum Type { TypeInteger, TypeProgress, TypeSelect, TypeString, TypeMultistring, TypeImages, TypeFiles };

		int id;

		std::wstring name;
		Type type;

		// used when type is TypeInteger or TypeProgress
		int integer_min, integer_max;

		// used when type is TypeSelect
		std::vector<Select> select;			
		size_t select_default;

		// used when type is TypeImages or TypeFiles
		// 0 - unlimited
		int max_files;
		std::wstring upload_dir;
	};

	typedef std::vector<TicketItem> Table;
	Table tab;

	void Clear();
};


#endif

