/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfilecmslutemplateslocalefilter
#define headerfilecmslutemplateslocalefilter


#include "locale.h"
#include "ezc.h"



class LocaleFilter
{
public:
	
	LocaleFilter();
	void Filter(Ezc::Pattern & pattern, const Locale & locale, Locale::Lang lang_);

private:
	void ReadKey();
	std::wstring & FilterValue(const std::wstring & in);
	void FilterText(Ezc::Item & item);
	void Parse(std::wstring & str);

	wchar_t open_mark;		// default '{'
	wchar_t closing_mark;	// default '}'

	const Locale * plocale;
	Locale::Lang lang;
	std::wstring res;
	std::wstring key;
	std::wstring value;
	const wchar_t * pchar;

};




#endif
